"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionCallWithOutcome = void 0;
const providers_1 = require("near-api-js/lib/providers");
/**
 * This function calls a change method, returning both the return value of the
 * call and the execution outcome.
 *
 * Some use cases need transaction/receipt IDs after calling a change method,
 * which makes the NEAR SDK's Contract class unsuitable.
 * https://github.com/near/near-api-js/blob/c84aef6cc18fe5ac1063411c95283ba3130fa656/src/contract.ts#L145
 */
function functionCallWithOutcome(account, params) {
    return __awaiter(this, void 0, void 0, function* () {
        const executionOutcome = yield account.functionCall(params);
        return {
            executionOutcome,
            response: (0, providers_1.getTransactionLastResult)(executionOutcome),
        };
    });
}
exports.functionCallWithOutcome = functionCallWithOutcome;
