"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decimalToBn = exports.bnToApproximateDecimal = exports.floorToBn = exports.floorToDecimals = exports.roundDownTo = exports.denomination = exports.ZERO = void 0;
const bn_js_1 = __importDefault(require("bn.js"));
const _1 = require(".");
const format_1 = require("./format");
exports.ZERO = new bn_js_1.default(0);
const denomination = (decimals) => {
    return new bn_js_1.default(decimals).pow(new bn_js_1.default(10));
};
exports.denomination = denomination;
const roundDownTo = (v, nearest) => {
    return v.div(nearest).mul(nearest);
};
exports.roundDownTo = roundDownTo;
const floorToDecimals = (v, decimals) => {
    if (decimals < 1) {
        throw new Error('decimals must be positive');
    }
    const mask = (0, exports.denomination)(decimals);
    return v.div(mask).mul(mask);
};
exports.floorToDecimals = floorToDecimals;
const floorToBn = (v, closest) => {
    return v.div(closest).mul(closest);
};
exports.floorToBn = floorToBn;
const bnToApproximateDecimal = (v, decimals, precision) => {
    return parseFloat((0, format_1.bnToFixed)(v, decimals, precision));
};
exports.bnToApproximateDecimal = bnToApproximateDecimal;
const decimalToBn = (price, decimals) => {
    return new bn_js_1.default((0, _1.toDecimalPaddedString)(price.toString(), decimals));
};
exports.decimalToBn = decimalToBn;
